## telepathy-spec 0.17.1

=== Makefile ===
all:

XSLTPROC = xsltproc --xinclude --nonet
CANONXML = xmllint --nsclean --noblanks --c14n --nonet
XML_LINEBREAKS = perl -pe 's/>/>\n/g'
DROP_NAMESPACE = perl -pe '$$hash = chr(35); s{xmlns:tp="http://telepathy\.freedesktop\.org/wiki/DbusSpec$${hash}extensions-v0"}{}g'

XMLS = $(wildcard spec/*.xml)
INTERFACE_XMLS = $(filter spec/[CMP]%.xml,$(XMLS))
INTROSPECT = $(INTERFACE_XMLS:spec/%.xml=introspect/%.xml)
ASYNC_INTROSPECT = $(INTERFACE_XMLS:spec/%.xml=introspect/async/%.xml)
CANONICAL_NAMES = $(INTERFACE_XMLS:spec/%.xml=tmp/%.name)

$(CANONICAL_NAMES): tmp/%.name: spec/%.xml tools/extract-nodename.py
	@install -d tmp
	python tools/extract-nodename.py $< > $@
	tr a-z A-Z < $@ > $@.upper
	tr A-Z a-z < $@ > $@.lower
	tr -d _ < $@ > $@.camel

TEST_XMLS = $(wildcard test/input/*.xml)
TEST_INTERFACE_XMLS = test/input/_Test.xml
TEST_INTROSPECT = test/output/_Test.introspect.xml
TEST_GENERATED_FILES = \
	test/output/spec.html \
	$(TEST_INTROSPECT) $(TEST_ASYNC_INTROSPECT)

GENERATED_FILES = \
	doc/spec.html \
	doc/telepathy-spec.devhelp2 \
	$(INTROSPECT) $(ASYNC_INTROSPECT) \
	$(CANONICAL_NAMES)

doc/spec.html: $(XMLS) tools/doc-generator.xsl
	$(XSLTPROC) tools/doc-generator.xsl spec/all.xml > $@
doc/telepathy-spec.devhelp2: $(XMLS) tools/devhelp.xsl
	$(XSLTPROC) tools/devhelp.xsl spec/all.xml > $@
test/output/spec.html: $(TEST_XMLS) tools/doc-generator.xsl
	@install -d test/output
	$(XSLTPROC) tools/doc-generator.xsl test/input/all.xml > $@

$(INTROSPECT): introspect/%.xml: spec/%.xml tools/spec-to-introspect.xsl
	@install -d introspect
	$(XSLTPROC) tools/spec-to-introspect.xsl $< | $(DROP_NAMESPACE) > $@
$(TEST_INTROSPECT): $(TEST_INTERFACE_XMLS) tools/spec-to-introspect.xsl
	@install -d test/output
	$(XSLTPROC) tools/spec-to-introspect.xsl $< | $(DROP_NAMESPACE) > $@

$(ASYNC_INTROSPECT): introspect/async/%.xml: introspect/%.xml tools/make_all_async.py
	@install -d introspect/async
	python tools/make_all_async.py $< $@
$(TEST_ASYNC_INTROSPECT): $(TEST_INTROSPECT) tools/make_all_async.py
	@install -d test/output
	python tools/make_all_async.py $< $@

all: $(GENERATED_FILES)

TEST_CANONICALIZED_FILES = test/output/spec.html.canon \
			   test/output/introspect.canon

test/output/spec.html.canon: test/output/spec.html
	$(CANONXML) $< > $@
test/output/introspect.canon: test/output/_Test.introspect.xml
	$(CANONXML) $< | $(XML_LINEBREAKS) > $@

check: all $(TEST_GENERATED_FILES) $(TEST_CANONICALIZED_FILES)
	@e=0; \
	diff -u test/expected/spec.html.canon test/output/spec.html.canon || e=1; \
	diff -u test/expected/introspect.canon test/output/introspect.canon || e=1; \
	exit $$e

clean:
	rm -f $(GENERATED_FILES)
	rm -fr introspect
	rm -rf test/output
	rm -rf tmp

maintainer-upload-snapshot: doc/spec.html
	cp doc/spec.html tmp/spec.html
	sed -i~ -e 's,\(<h2>Version [0-9][0-9.]*\)\(</h2>\),\1 (darcs snapshot '`date +%Y%m%d`')\2,' \
		tmp/spec.html
	scp tmp/spec.html \
		telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot.html

dist:
	set -e ;\
	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
	distname="telepathy-spec-$$version";\
	darcs dist -d dist;\
	tar -zxf- -C tmp < dist.tar.gz;\
	darcs changes > tmp/dist/ChangeLog;\
	rm -rf tmp/"$$distname";\
	mv tmp/dist tmp/"$$distname";\
	tar -zcvf- -C tmp "$$distname" > tmp/"$$distname".tar.gz;\
	mv tmp/"$$distname".tar.gz .;\
	rm -rf tmp/"$$distname";\
	rm -f dist.tar.gz

## telepathy-spec 0.17.7

=== Makefile ===
--- 
+++ 
@@ -4,9 +4,10 @@
 CANONXML = xmllint --nsclean --noblanks --c14n --nonet
 XML_LINEBREAKS = perl -pe 's/>/>\n/g'
 DROP_NAMESPACE = perl -pe '$$hash = chr(35); s{xmlns:tp="http://telepathy\.freedesktop\.org/wiki/DbusSpec$${hash}extensions-v0"}{}g'
+RST2HTML = rst2html
 
 XMLS = $(wildcard spec/*.xml)
-INTERFACE_XMLS = $(filter spec/[CMP]%.xml,$(XMLS))
+INTERFACE_XMLS = $(filter spec/[[:upper:]]%.xml,$(XMLS))
 INTROSPECT = $(INTERFACE_XMLS:spec/%.xml=introspect/%.xml)
 ASYNC_INTROSPECT = $(INTERFACE_XMLS:spec/%.xml=introspect/async/%.xml)
 CANONICAL_NAMES = $(INTERFACE_XMLS:spec/%.xml=tmp/%.name)
@@ -25,7 +26,12 @@
 	test/output/spec.html \
 	$(TEST_INTROSPECT) $(TEST_ASYNC_INTROSPECT)
 
+doc/request.html doc/dispatch.html: %.html: %.txt
+	$(RST2HTML) < $< > $@
+
 GENERATED_FILES = \
+	doc/request.html \
+	doc/dispatch.html \
 	doc/spec.html \
 	doc/telepathy-spec.devhelp2 \
 	$(INTROSPECT) $(ASYNC_INTROSPECT) \
@@ -76,6 +82,7 @@
 	rm -rf tmp
 
 maintainer-upload-snapshot: doc/spec.html
+	@install -d tmp
 	cp doc/spec.html tmp/spec.html
 	sed -i~ -e 's,\(<h2>Version [0-9][0-9.]*\)\(</h2>\),\1 (darcs snapshot '`date +%Y%m%d`')\2,' \
 		tmp/spec.html
@@ -83,6 +90,7 @@
 		telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot.html
 
 dist:
+	@install -d tmp
 	set -e ;\
 	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
 	distname="telepathy-spec-$$version";\

## telepathy-spec 0.17.9

=== Makefile ===
--- 
+++ 
@@ -89,6 +89,22 @@
 	scp tmp/spec.html \
 		telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot.html
 
+maintainer-upload-release: doc/spec.html
+	@install -d tmp
+	set -e ; \
+	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
+	if ! echo $$version | egrep '[0-9]+\.[0-9]+\.[0-9]+'; then \
+		echo 'This does not look like a spec release'; \
+		exit 1; \
+	fi; \
+	test -f telepathy-spec-$$version.tar.gz; \
+	test -f telepathy-spec-$$version.tar.gz.asc; \
+	gpg --verify telepathy-spec-$$version.tar.gz.asc; \
+	rsync -vzP telepathy-spec-$$version.tar.gz telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
+	rsync -vzP telepathy-spec-$$version.tar.gz.asc telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
+	rsync -vzP doc/spec.html telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot.html ; \
+	rsync -vzP doc/spec.html telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec.html
+
 dist:
 	@install -d tmp
 	set -e ;\
@@ -103,3 +119,11 @@
 	mv tmp/"$$distname".tar.gz .;\
 	rm -rf tmp/"$$distname";\
 	rm -f dist.tar.gz
+
+BRANCH = misc
+UPLOAD_BRANCH_TO = people.freedesktop.org:public_html/telepathy-spec
+
+# Usage: make upload-branch BRANCH=discussion
+upload-branch: all
+	rsync -zvP doc/spec.html $(patsubst %.txt,%.html,$(RST)) \
+		$(UPLOAD_BRANCH_TO)-$(BRANCH)/

## telepathy-spec 0.18.0

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,17 @@
 all:
 
+GIT = git
+GZIP = gzip
+TAR = tar
 XSLTPROC = xsltproc --xinclude --nonet
 CANONXML = xmllint --nsclean --noblanks --c14n --nonet
 XML_LINEBREAKS = perl -pe 's/>/>\n/g'
 DROP_NAMESPACE = perl -pe '$$hash = chr(35); s{xmlns:tp="http://telepathy\.freedesktop\.org/wiki/DbusSpec$${hash}extensions-v0"}{}g'
 RST2HTML = rst2html
+PYTHON = python
 
 XMLS = $(wildcard spec/*.xml)
+TEMPLATES = $(wildcard doc/templates/*)
 INTERFACE_XMLS = $(filter spec/[[:upper:]]%.xml,$(XMLS))
 INTROSPECT = $(INTERFACE_XMLS:spec/%.xml=introspect/%.xml)
 ASYNC_INTROSPECT = $(INTERFACE_XMLS:spec/%.xml=introspect/async/%.xml)
@@ -26,24 +31,42 @@
 	test/output/spec.html \
 	$(TEST_INTROSPECT) $(TEST_ASYNC_INTROSPECT)
 
-doc/request.html doc/dispatch.html: %.html: %.txt
+RST = \
+    doc/cmcaps.txt \
+    doc/clientcaps.txt \
+    doc/open-issues.txt \
+    doc/request.txt \
+    doc/dispatch.txt
+
+$(patsubst %.txt,%.html,$(RST)): %.html: %.txt Makefile
 	$(RST2HTML) < $< > $@
 
 GENERATED_FILES = \
-	doc/request.html \
-	doc/dispatch.html \
+	$(patsubst %.txt,%.html,$(RST)) \
 	doc/spec.html \
+	doc/spec/index.html \
 	doc/telepathy-spec.devhelp2 \
 	$(INTROSPECT) $(ASYNC_INTROSPECT) \
 	$(CANONICAL_NAMES)
 
 doc/spec.html: $(XMLS) tools/doc-generator.xsl
-	$(XSLTPROC) tools/doc-generator.xsl spec/all.xml > $@
+	@install -d tmp/doc
+	$(XSLTPROC) tools/doc-generator.xsl spec/all.xml > tmp/$@
+	mv tmp/$@ $@
 doc/telepathy-spec.devhelp2: $(XMLS) tools/devhelp.xsl
-	$(XSLTPROC) tools/devhelp.xsl spec/all.xml > $@
+	@install -d tmp/doc
+	$(XSLTPROC) tools/devhelp.xsl spec/all.xml > tmp/$@
+	mv tmp/$@ $@
 test/output/spec.html: $(TEST_XMLS) tools/doc-generator.xsl
+	@install -d tmp/test/output
 	@install -d test/output
-	$(XSLTPROC) tools/doc-generator.xsl test/input/all.xml > $@
+	$(XSLTPROC) tools/doc-generator.xsl test/input/all.xml > tmp/$@
+	mv tmp/$@ $@
+
+doc/spec/index.html: $(XMLS) tools/doc-generator.py tools/specparser.py $(TEMPLATES)
+	@install -d doc
+	$(PYTHON) tools/doc-generator.py spec/all.xml doc/spec/ telepathy-spec \
+		org.freedesktop.Telepathy
 
 $(INTROSPECT): introspect/%.xml: spec/%.xml tools/spec-to-introspect.xsl
 	@install -d introspect
@@ -81,15 +104,16 @@
 	rm -rf test/output
 	rm -rf tmp
 
-maintainer-upload-snapshot: doc/spec.html
+maintainer-upload-snapshot: doc/spec.html doc/spec/index.html
 	@install -d tmp
 	cp doc/spec.html tmp/spec.html
-	sed -i~ -e 's,\(<h2>Version [0-9][0-9.]*\)\(</h2>\),\1 (darcs snapshot '`date +%Y%m%d`')\2,' \
+	sed -i~ -e 's!\(<h2>Version [0-9][0-9.]*\)\(</h2>\)!\1 (git commit '`git rev-list -n 1 --abbrev-commit --abbrev=8 HEAD`', '`date +%Y-%m-%d`')\2!' \
 		tmp/spec.html
 	scp tmp/spec.html \
 		telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot.html
+	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/
 
-maintainer-upload-release: doc/spec.html
+maintainer-upload-release: doc/spec.html doc/spec/index.html
 	@install -d tmp
 	set -e ; \
 	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
@@ -103,6 +127,8 @@
 	rsync -vzP telepathy-spec-$$version.tar.gz telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
 	rsync -vzP telepathy-spec-$$version.tar.gz.asc telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
 	rsync -vzP doc/spec.html telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot.html ; \
+	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec/ ; \
+	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/ ; \
 	rsync -vzP doc/spec.html telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec.html
 
 dist:
@@ -110,20 +136,25 @@
 	set -e ;\
 	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
 	distname="telepathy-spec-$$version";\
-	darcs dist -d dist;\
-	tar -zxf- -C tmp < dist.tar.gz;\
-	darcs changes > tmp/dist/ChangeLog;\
+	rm -f tmp/ChangeLog "$$distname".tar "$$distname".tar.gz; \
+	$(GIT) archive --format=tar --prefix="$$distname"/ "HEAD^{tree}" \
+		> "$$distname".tar;\
 	rm -rf tmp/"$$distname";\
-	mv tmp/dist tmp/"$$distname";\
-	tar -zcvf- -C tmp "$$distname" > tmp/"$$distname".tar.gz;\
-	mv tmp/"$$distname".tar.gz .;\
-	rm -rf tmp/"$$distname";\
-	rm -f dist.tar.gz
+	mkdir tmp/"$$distname";\
+	$(GIT) log --stat > tmp/"$$distname"/ChangeLog || \
+		$(GIT) log > tmp/"$$distname"/ChangeLog;\
+	$(TAR) -rf "$$distname".tar -C tmp --owner 0 --group 0 --mode 0664 \
+		"$$distname"/ChangeLog;\
+	$(GZIP) -9 "$$distname".tar;\
+	$(TAR) -ztvf "$$distname".tar.gz;\
+	rm -rf tmp/"$$distname"
 
-BRANCH = misc
+BRANCH = $(shell sh tools/git-which-branch.sh misc | tr -d '\n' | tr -C "[:alnum:]" _)
 UPLOAD_BRANCH_TO = people.freedesktop.org:public_html/telepathy-spec
 
 # Usage: make upload-branch BRANCH=discussion
 upload-branch: all
-	rsync -zvP doc/spec.html $(patsubst %.txt,%.html,$(RST)) \
+	rsync -rzvP doc/spec.html $(patsubst %.txt,%.html,$(RST)) doc/spec \
 		$(UPLOAD_BRANCH_TO)-$(BRANCH)/
+	@echo Your spec branch might be at:
+	@echo '  ' http://people.freedesktop.org/~$$USER/telepathy-spec-$(BRANCH)/

## telepathy-spec 0.19.0

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,6 @@
 TEST_INTERFACE_XMLS = test/input/_Test.xml
 TEST_INTROSPECT = test/output/_Test.introspect.xml
 TEST_GENERATED_FILES = \
-	test/output/spec.html \
 	$(TEST_INTROSPECT) $(TEST_ASYNC_INTROSPECT)
 
 RST = \
@@ -49,18 +48,11 @@
 	$(INTROSPECT) $(ASYNC_INTROSPECT) \
 	$(CANONICAL_NAMES)
 
-doc/spec.html: $(XMLS) tools/doc-generator.xsl
-	@install -d tmp/doc
-	$(XSLTPROC) tools/doc-generator.xsl spec/all.xml > tmp/$@
-	mv tmp/$@ $@
+doc/spec.html: doc/templates/oldspec.html
+	cp $< $@
 doc/telepathy-spec.devhelp2: $(XMLS) tools/devhelp.xsl
 	@install -d tmp/doc
 	$(XSLTPROC) tools/devhelp.xsl spec/all.xml > tmp/$@
-	mv tmp/$@ $@
-test/output/spec.html: $(TEST_XMLS) tools/doc-generator.xsl
-	@install -d tmp/test/output
-	@install -d test/output
-	$(XSLTPROC) tools/doc-generator.xsl test/input/all.xml > tmp/$@
 	mv tmp/$@ $@
 
 doc/spec/index.html: $(XMLS) tools/doc-generator.py tools/specparser.py $(TEMPLATES)
@@ -83,18 +75,18 @@
 	python tools/make_all_async.py $< $@
 
 all: $(GENERATED_FILES)
+	@echo "Your spec HTML starts at:"
+	@echo
+	@echo file://$(CURDIR)/doc/spec/index.html
+	@echo
 
-TEST_CANONICALIZED_FILES = test/output/spec.html.canon \
-			   test/output/introspect.canon
+TEST_CANONICALIZED_FILES = test/output/introspect.canon
 
-test/output/spec.html.canon: test/output/spec.html
-	$(CANONXML) $< > $@
 test/output/introspect.canon: test/output/_Test.introspect.xml
 	$(CANONXML) $< | $(XML_LINEBREAKS) > $@
 
 check: all $(TEST_GENERATED_FILES) $(TEST_CANONICALIZED_FILES)
 	@e=0; \
-	diff -u test/expected/spec.html.canon test/output/spec.html.canon || e=1; \
 	diff -u test/expected/introspect.canon test/output/introspect.canon || e=1; \
 	exit $$e
 
@@ -104,16 +96,11 @@
 	rm -rf test/output
 	rm -rf tmp
 
-maintainer-upload-snapshot: doc/spec.html doc/spec/index.html
+maintainer-upload-snapshot: doc/spec/index.html
 	@install -d tmp
-	cp doc/spec.html tmp/spec.html
-	sed -i~ -e 's!\(<h2>Version [0-9][0-9.]*\)\(</h2>\)!\1 (git commit '`git rev-list -n 1 --abbrev-commit --abbrev=8 HEAD`', '`date +%Y-%m-%d`')\2!' \
-		tmp/spec.html
-	scp tmp/spec.html \
-		telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot.html
 	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/
 
-maintainer-upload-release: doc/spec.html doc/spec/index.html
+maintainer-upload-release: doc/spec/index.html
 	@install -d tmp
 	set -e ; \
 	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
@@ -126,10 +113,8 @@
 	gpg --verify telepathy-spec-$$version.tar.gz.asc; \
 	rsync -vzP telepathy-spec-$$version.tar.gz telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
 	rsync -vzP telepathy-spec-$$version.tar.gz.asc telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
-	rsync -vzP doc/spec.html telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot.html ; \
 	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec/ ; \
-	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/ ; \
-	rsync -vzP doc/spec.html telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec.html
+	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/
 
 dist:
 	@install -d tmp
@@ -141,8 +126,7 @@
 		> "$$distname".tar;\
 	rm -rf tmp/"$$distname";\
 	mkdir tmp/"$$distname";\
-	$(GIT) log --stat > tmp/"$$distname"/ChangeLog || \
-		$(GIT) log > tmp/"$$distname"/ChangeLog;\
+	$(GIT) log telepathy-spec-0.16.0.. > tmp/"$$distname"/ChangeLog; \
 	$(TAR) -rf "$$distname".tar -C tmp --owner 0 --group 0 --mode 0664 \
 		"$$distname"/ChangeLog;\
 	$(GZIP) -9 "$$distname".tar;\
@@ -157,4 +141,4 @@
 	rsync -rzvP doc/spec.html $(patsubst %.txt,%.html,$(RST)) doc/spec \
 		$(UPLOAD_BRANCH_TO)-$(BRANCH)/
 	@echo Your spec branch might be at:
-	@echo '  ' http://people.freedesktop.org/~$$USER/telepathy-spec-$(BRANCH)/
+	@echo '  ' http://people.freedesktop.org/~$$USER/telepathy-spec-$(BRANCH)/spec/

## telepathy-spec 0.19.10

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,6 @@
 TEMPLATES = $(wildcard doc/templates/*)
 INTERFACE_XMLS = $(filter spec/[[:upper:]]%.xml,$(XMLS))
 INTROSPECT = $(INTERFACE_XMLS:spec/%.xml=introspect/%.xml)
-ASYNC_INTROSPECT = $(INTERFACE_XMLS:spec/%.xml=introspect/async/%.xml)
 CANONICAL_NAMES = $(INTERFACE_XMLS:spec/%.xml=tmp/%.name)
 
 $(CANONICAL_NAMES): tmp/%.name: spec/%.xml tools/extract-nodename.py
@@ -27,8 +26,7 @@
 TEST_XMLS = $(wildcard test/input/*.xml)
 TEST_INTERFACE_XMLS = test/input/_Test.xml
 TEST_INTROSPECT = test/output/_Test.introspect.xml
-TEST_GENERATED_FILES = \
-	$(TEST_INTROSPECT) $(TEST_ASYNC_INTROSPECT)
+TEST_GENERATED_FILES = $(TEST_INTROSPECT)
 
 RST = \
     doc/cmcaps.txt \
@@ -44,16 +42,12 @@
 	$(patsubst %.txt,%.html,$(RST)) \
 	doc/spec.html \
 	doc/spec/index.html \
-	doc/telepathy-spec.devhelp2 \
-	$(INTROSPECT) $(ASYNC_INTROSPECT) \
+	FIXME.out \
+	$(INTROSPECT) \
 	$(CANONICAL_NAMES)
 
 doc/spec.html: doc/templates/oldspec.html
 	cp $< $@
-doc/telepathy-spec.devhelp2: $(XMLS) tools/devhelp.xsl
-	@install -d tmp/doc
-	$(XSLTPROC) tools/devhelp.xsl spec/all.xml > tmp/$@
-	mv tmp/$@ $@
 
 doc/spec/index.html: $(XMLS) tools/doc-generator.py tools/specparser.py $(TEMPLATES)
 	@install -d doc
@@ -67,13 +61,6 @@
 	@install -d test/output
 	$(XSLTPROC) tools/spec-to-introspect.xsl $< | $(DROP_NAMESPACE) > $@
 
-$(ASYNC_INTROSPECT): introspect/async/%.xml: introspect/%.xml tools/make_all_async.py
-	@install -d introspect/async
-	python tools/make_all_async.py $< $@
-$(TEST_ASYNC_INTROSPECT): $(TEST_INTROSPECT) tools/make_all_async.py
-	@install -d test/output
-	python tools/make_all_async.py $< $@
-
 all: $(GENERATED_FILES)
 	@echo "Your spec HTML starts at:"
 	@echo
@@ -85,10 +72,28 @@
 test/output/introspect.canon: test/output/_Test.introspect.xml
 	$(CANONXML) $< | $(XML_LINEBREAKS) > $@
 
-check: all $(TEST_GENERATED_FILES) $(TEST_CANONICALIZED_FILES)
+CHECK_FOR_UNRELEASED = NEWS $(filter-out spec/template.xml,$(XMLS))
+
+check: all $(TEST_GENERATED_FILES) $(TEST_CANONICALIZED_FILES) FIXME.out
 	@e=0; \
 	diff -u test/expected/introspect.canon test/output/introspect.canon || e=1; \
 	exit $$e
+	@version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
+	case "$$version" in \
+		*.*.*.*) ;; \
+		*) \
+			if grep -r UNRELEASED $(CHECK_FOR_UNRELEASED); \
+			then \
+				echo "^^^ This is meant to be a release, but some files say UNRELEASED" >&2; \
+				exit 2; \
+			fi \
+			;; \
+	esac
+
+FIXME.out: $(XMLS)
+	@echo '  GEN   ' $@
+	@egrep -A 5 '[F]IXME|[T]ODO|[X]XX' $(XMLS) \
+		> FIXME.out || true
 
 clean:
 	rm -f $(GENERATED_FILES)
@@ -98,9 +103,11 @@
 
 maintainer-upload-snapshot: doc/spec/index.html
 	@install -d tmp
-	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/
+	rsync -rvzPp --chmod=Dg+s,ug+rwX,o=rX doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/
+	@echo The snapshot lives at:
+	@echo '  ' http://telepathy.freedesktop.org/spec-snapshot/
 
-maintainer-upload-release: doc/spec/index.html
+maintainer-upload-release: doc/spec/index.html check
 	@install -d tmp
 	set -e ; \
 	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
@@ -113,10 +120,10 @@
 	gpg --verify telepathy-spec-$$version.tar.gz.asc; \
 	rsync -vzP telepathy-spec-$$version.tar.gz telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
 	rsync -vzP telepathy-spec-$$version.tar.gz.asc telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
-	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec/ ; \
-	rsync -rvzP doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/
+	rsync -rvzPp --chmod=Dg+s,ug+rwX,o=rX doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec/ ; \
+	rsync -rvzPp --chmod=Dg+s,ug+rwX,o=rX doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/
 
-dist:
+dist: check
 	@install -d tmp
 	set -e ;\
 	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\

=== debian/changelog ===
telepathy-spec (0.19.10-1) unstable; urgency=low

  * New upstream version
  * Standards-Version: 3.9.1 (no changes)

 -- Simon McVittie <smcv@debian.org>  Mon, 26 Jul 2010 12:20:01 +0100

telepathy-spec (0.19.8-1) unstable; urgency=low

  * New upstream version
  * Simplify debian/rules using override_dh_foo
  * Stop installing the HTML twice; make the version in /usr/share/doc
    a symlink into /usr/share/gtk-doc/html instead
  * Recommend libjs-jquery, to have collapsible rationales without shipping
    a duplicate copy in telepathy-specification; if you don't install it,
    jquery.min.js will be a dangling symlink and rationale sections will
    always be shown
  * Standards-Version: 3.9.0 (no changes)

 -- Simon McVittie <smcv@debian.org>  Thu, 01 Jul 2010 14:49:42 +0100

telepathy-spec (0.19.7-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Mon, 14 Jun 2010 14:00:21 +0100

telepathy-spec (0.19.6-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Mon, 31 May 2010 17:09:05 +0100

telepathy-spec (0.19.5-1) unstable; urgency=low

  * New upstream version(s)
  * Use machine-readable copyright format
  * Relicense packaging to be the same as the spec (with bigon's permission)
  * Use source format 3.0
  * clean: clean up more files, fixing repeated builds

 -- Simon McVittie <smcv@debian.org>  Fri, 16 Apr 2010 14:51:36 +0100

telepathy-spec (0.19.1-1) unstable; urgency=low

  * New upstream version
  * Standards-Version: 3.8.4 (no changes needed)

 -- Simon McVittie <smcv@debian.org>  Wed, 24 Feb 2010 15:16:55 +0000

telepathy-spec (0.19.0-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Tue, 01 Dec 2009 18:31:22 +0000

telepathy-spec (0.18.0-1) unstable; urgency=low

  * New upstream stable version

 -- Simon McVittie <smcv@debian.org>  Thu, 24 Sep 2009 14:22:30 +0100

telepathy-spec (0.17.28-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Mon, 14 Sep 2009 16:56:09 +0100

telepathy-spec (0.17.27-1) unstable; urgency=low

  * New upstream version
  * Standards-Version: 3.8.3, no changes needed

 -- Simon McVittie <smcv@debian.org>  Sun, 16 Aug 2009 16:18:08 +0100

telepathy-spec (0.17.25-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Wed, 27 May 2009 18:44:01 +0100

telepathy-spec (0.17.23-1) unstable; urgency=low

  [ Laurent Bigonville ]
  * New upstream version
  * Add python-cheetah build-dep 

  [ Jonny Lamb ]
  * New upstream release.
  * debian/control:
    + Added myself to Uploaders.
    + Removed XS-Dm-Upload-Allowed field.
  * debian/copyright: Updated years and links to copyright files in
    common-licenses.
  * debian/gbp.conf: Removed no-create-orig line.
  * debian/install: Install new and old-style spec formats.
  * debian/doc-base: Updated references to documentation.

 -- Jonny Lamb <jonny@debian.org>  Tue, 21 Apr 2009 20:22:06 +0100

telepathy-spec (0.17.21-1) unstable; urgency=low

  * New upstream version
  * Standards-Version: 3.8.1 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Tue, 17 Mar 2009 19:25:32 +0000

telepathy-spec (0.17.19-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Wed, 28 Jan 2009 15:48:23 +0000

telepathy-spec (0.17.18-1) unstable; urgency=low

  * New upstream version
  * debian/gbp.conf: use pristine-tar automatically

 -- Simon McVittie <smcv@debian.org>  Tue, 20 Jan 2009 12:17:14 +0000

telepathy-spec (0.17.17-1) unstable; urgency=low

  * New upstream version
  * lintian: remove duplication of Section between source and binary control
    stanzas

 -- Simon McVittie <smcv@debian.org>  Tue, 06 Jan 2009 20:20:25 +0000

telepathy-spec (0.17.16-1) unstable; urgency=low

  * New upstream release
  * Switch packaging to git
  * Standards-Version: 3.8.0 (no changes)

 -- Simon McVittie <smcv@debian.org>  Thu, 18 Dec 2008 01:10:33 +0000

telepathy-spec (0.17.15-1) unstable; urgency=low

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Fri, 21 Nov 2008 17:17:32 +0000

telepathy-spec (0.17.14-1) unstable; urgency=low

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Thu, 30 Oct 2008 17:36:52 +0000

telepathy-spec (0.17.13-1) unstable; urgency=low

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Mon, 13 Oct 2008 17:35:10 +0100

telepathy-spec (0.17.12-1) unstable; urgency=low

  [ Simon McVittie ]
  * New upstream release

  [ Laurent Bigonville ]
  * Use my debian.org address in Uploaders

 -- Simon McVittie <smcv@debian.org>  Fri, 26 Sep 2008 16:22:19 +0100

telepathy-spec (0.17.11-1) unstable; urgency=low

  * New upstream release
  * Install the spec XML itself, to /usr/share/doc/telepathy-specification/spec

 -- Simon McVittie <smcv@debian.org>  Fri, 12 Sep 2008 17:12:27 +0100

telepathy-spec (0.17.10-1) unstable; urgency=low

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Tue, 09 Sep 2008 16:18:16 +0100

telepathy-spec (0.17.9-1) unstable; urgency=low

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Fri, 15 Aug 2008 16:28:01 +0100

telepathy-spec (0.17.8-1) unstable; urgency=low

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Wed, 23 Jul 2008 20:39:49 +0100

telepathy-spec (0.17.7-1) unstable; urgency=low

  * New upstream release
    - build now requires python-docutils

 -- Simon McVittie <smcv@debian.org>  Thu, 05 Jun 2008 17:26:42 +0100

telepathy-spec (0.17.6-1) unstable; urgency=low

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Mon, 26 May 2008 18:36:07 +0100

telepathy-spec (0.17.5-1) unstable; urgency=low

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Wed, 21 May 2008 16:35:13 +0100

telepathy-spec (0.17.4-1) unstable; urgency=low

  * New upstream release
  * Use my debian.org address in Uploaders
  * Update years in debian/copyright


=== debian/control ===
Source: telepathy-spec
Section: doc
Priority: optional
Maintainer: Debian Telepathy maintainers <pkg-telepathy-maintainers@lists.alioth.debian.org>
Uploaders: Laurent Bigonville <bigon@debian.org>,
           Simon McVittie <smcv@debian.org>,
           Sjoerd Simons <sjoerd@debian.org>,
           Jonny Lamb <jonny@debian.org>
Build-Depends: debhelper (>= 7.0.50)
Build-Depends-Indep: xsltproc,
                     python (>= 2.5) | python-elementtree,
                     python-docutils,
                     python-cheetah
Standards-Version: 3.9.1
Vcs-Git: git://git.debian.org/git/pkg-telepathy/telepathy-spec.git
Vcs-Browser: http://git.debian.org/?p=pkg-telepathy/telepathy-spec.git
Homepage: http://telepathy.freedesktop.org/wiki/

Package: telepathy-specification
Architecture: all
Depends: ${misc:Depends}
Recommends: libjs-jquery
Suggests: doc-base
Enhances: libtelepathy-dev, libtelepathy-glib-doc
Description: Telepathy D-Bus specification
 Telepathy is a D-Bus framework for unifying real time communication,
 including instant messaging, voice calls and video calls. It abstracts
 differences between protocols to provide a unified interface for
 applications.
 .
 The specification can be browsed with the devhelp documentation
 browser, or with a regular web browser.

=== debian/watch ===
version=3
http://telepathy.freedesktop.org/releases/telepathy-spec/telepathy-spec-(.*).tar.gz

## telepathy-spec 0.20.0

=== debian/changelog ===
telepathy-spec (0.20.0-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Tue, 14 Sep 2010 18:59:44 +0100

telepathy-spec (0.19.11-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Mon, 09 Aug 2010 18:10:33 +0100

## telepathy-spec 0.21.4

=== debian/changelog ===
telepathy-spec (0.21.4-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Wed, 03 Nov 2010 15:58:06 +0000

telepathy-spec (0.21.2-1) unstable; urgency=low

  * New upstream version
  * Remove dead symlink to single-file spec (Closes: #598642)

 -- Simon McVittie <smcv@debian.org>  Fri, 15 Oct 2010 15:57:56 +0100

## telepathy-spec 0.21.5

=== debian/changelog ===
telepathy-spec (0.21.5-1) unstable; urgency=low

  * New upstream version
    - drop dispatch.html, request.html and docutils dependency: removed
      upstream

 -- Simon McVittie <smcv@debian.org>  Thu, 25 Nov 2010 16:45:27 +0000

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
 Build-Depends: debhelper (>= 7.0.50)
 Build-Depends-Indep: xsltproc,
                      python (>= 2.5) | python-elementtree,
-                     python-docutils,
                      python-cheetah
 Standards-Version: 3.9.1
 Vcs-Git: git://git.debian.org/git/pkg-telepathy/telepathy-spec.git

## telepathy-spec 0.21.6

=== debian/changelog ===
telepathy-spec (0.21.6-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Wed, 01 Dec 2010 18:38:43 +0000

## telepathy-spec 0.21.8

=== debian/changelog ===
telepathy-spec (0.21.8-1) unstable; urgency=low

  * New upstream version
  * debian/control:
    - Add myself to Uploaders.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Mon, 27 Dec 2010 02:30:35 +0000

telepathy-spec (0.21.7-1) unstable; urgency=low

  * New upstream version

 -- Simon McVittie <smcv@debian.org>  Mon, 13 Dec 2010 16:46:52 +0000

## telepathy-spec 0.21.11

=== Makefile ===
all:

GIT = git
GZIP = gzip
TAR = tar
PYTHON = python

DOC_RSYNC_FLAGS=-rvzPp --chmod=Dg+s,ug+rwX,o=rX --delete

XMLS = $(wildcard spec/*.xml)
TEMPLATES = $(wildcard doc/templates/*)

GENERATED_FILES = \
	doc/spec/index.html \
	FIXME.out \
	$(NULL)

doc/spec/index.html: $(XMLS) tools/doc-generator.py tools/specparser.py $(TEMPLATES)
	rm -rf doc/spec
	install -d doc/spec
	$(PYTHON) tools/doc-generator.py spec/all.xml doc/spec/ telepathy-spec \
		org.freedesktop.Telepathy

all: $(GENERATED_FILES)
	@echo "Your spec HTML starts at:"
	@echo
	@echo file://$(CURDIR)/doc/spec/index.html
	@echo

CHECK_FOR_UNRELEASED = NEWS $(filter-out spec/template.xml,$(XMLS))

check: all FIXME.out
	$(PYTHON) test/test-specparser.py
	@version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
	case "$$version" in \
		*.*.*.*) ;; \
		*) \
			if grep -r UNRELEASED $(CHECK_FOR_UNRELEASED); \
			then \
				echo "^^^ This is meant to be a release, but some files say UNRELEASED" >&2; \
				exit 2; \
			fi \
			;; \
	esac

FIXME.out: $(XMLS)
	@echo '  GEN   ' $@
	@egrep -A 5 '[F]IXME|[T]ODO|[X]XX' $(XMLS) \
		> FIXME.out || true

clean:
	rm -f $(GENERATED_FILES)
	rm -rf test/output
	rm -rf tmp
	rm -rf doc/spec

maintainer-upload-snapshot: doc/spec/index.html
	@install -d tmp
	rsync $(DOC_RSYNC_FLAGS) doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/
	@echo The snapshot lives at:
	@echo '  ' http://telepathy.freedesktop.org/spec-snapshot/

maintainer-upload-release: doc/spec/index.html check
	@install -d tmp
	set -e ; \
	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
	if ! echo $$version | egrep '[0-9]+\.[0-9]+\.[0-9]+'; then \
		echo 'This does not look like a spec release'; \
		exit 1; \
	fi; \
	test -f telepathy-spec-$$version.tar.gz; \
	test -f telepathy-spec-$$version.tar.gz.asc; \
	gpg --verify telepathy-spec-$$version.tar.gz.asc; \
	rsync -vzP telepathy-spec-$$version.tar.gz telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
	rsync -vzP telepathy-spec-$$version.tar.gz.asc telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/ ; \
	rsync $(DOC_RSYNC_FLAGS) doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec/ ; \
	rsync $(DOC_RSYNC_FLAGS) doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/

dist: check
	@install -d tmp
	set -e ;\
	version="`sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml`";\
	distname="telepathy-spec-$$version";\
	rm -f tmp/ChangeLog "$$distname".tar "$$distname".tar.gz; \
	$(GIT) archive --format=tar --prefix="$$distname"/ "HEAD^{tree}" \
		> "$$distname".tar;\
	rm -rf tmp/"$$distname";\
	mkdir tmp/"$$distname";\
	$(GIT) log telepathy-spec-0.16.0.. > tmp/"$$distname"/ChangeLog; \
	$(TAR) -rf "$$distname".tar -C tmp --owner 0 --group 0 --mode 0664 \
		"$$distname"/ChangeLog;\
	$(GZIP) -9 "$$distname".tar;\
	$(TAR) -ztvf "$$distname".tar.gz;\
	rm -rf tmp/"$$distname"

BRANCH = $(shell sh tools/git-which-branch.sh misc | tr -d '\n' | tr -C "[:alnum:]" _)
UPLOAD_BRANCH_TO = people.freedesktop.org:public_html/telepathy-spec

# Usage: make upload-branch BRANCH=discussion
upload-branch: all
	rsync -rzvP --delete doc/spec \
		$(UPLOAD_BRANCH_TO)-$(BRANCH)/
	@echo Your spec branch might be at:
	@echo '  ' http://people.freedesktop.org/~$$USER/telepathy-spec-$(BRANCH)/spec/

# automake requires these rules for anything that's in DIST_SUBDIRS
distclean: clean
maintainer-clean: clean
distdir:
	@echo distdir not implemented yet; exit 1

.PHONY: \
    all \
    check \
    clean \
    dist \
    distclean \
    distdir \
    maintainer-clean \
    maintainer-upload-release \
    maintainer-upload-snapshot \
    upload-branch \
    $(NULL)

=== debian/changelog ===
telepathy-spec (0.21.11-1) unstable; urgency=low

  * New upstream release

 -- Sjoerd Simons <sjoerd@debian.org>  Sat, 05 Mar 2011 15:22:10 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Uploaders: Laurent Bigonville <bigon@debian.org>,
            Simon McVittie <smcv@debian.org>,
            Sjoerd Simons <sjoerd@debian.org>,
-           Jonny Lamb <jonny@debian.org>
+           Jonny Lamb <jonny@debian.org>,
+           Emilio Pozuelo Monfort <pochu@debian.org>
 Build-Depends: debhelper (>= 7.0.50)
 Build-Depends-Indep: xsltproc,
                      python (>= 2.5) | python-elementtree,

## telepathy-spec 0.23.3

=== debian/changelog ===
telepathy-spec (0.23.3-1) unstable; urgency=low

  * New upstream release.

 -- Jonny Lamb <jonny@debian.org>  Mon, 25 Jul 2011 14:56:15 +0100

telepathy-spec (0.23.2-1) unstable; urgency=low

  * New upstream release.

 -- Jonny Lamb <jonny@debian.org>  Tue, 17 May 2011 08:12:42 +0100

telepathy-spec (0.23.1-1) unstable; urgency=low

  * New upstream release

 -- Sjoerd Simons <sjoerd@debian.org>  Sat, 14 May 2011 16:17:47 +0100

## telepathy-spec 0.24.0

=== debian/changelog ===
telepathy-spec (0.24.0-1) unstable; urgency=low

  * New upstream release.

 -- Jonny Lamb <jonny@debian.org>  Wed, 19 Oct 2011 10:40:26 +0100

telepathy-spec (0.23.4-1) unstable; urgency=low

  * New ustream release.

 -- Jonny Lamb <jonny@debian.org>  Wed, 05 Oct 2011 11:22:31 +0100

## telepathy-spec 0.25.0

=== debian/changelog ===
telepathy-spec (0.25.0-1) unstable; urgency=low

  * New upstream release.

 -- Jonny Lamb <jonny@debian.org>  Fri, 11 Nov 2011 16:43:44 +0000

## telepathy-spec 0.26.0

=== debian/changelog ===
telepathy-spec (0.26.0-1) unstable; urgency=low

  * New upstream release
  * Standards-Version: 3.9.3 (no changes)

 -- Simon McVittie <smcv@debian.org>  Fri, 13 Apr 2012 15:55:35 +0100

telepathy-spec (0.25.2-1) unstable; urgency=low

  * New upstream release.

 -- Simon McVittie <smcv@debian.org>  Mon, 20 Feb 2012 16:41:37 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Build-Depends-Indep: xsltproc,
                      python (>= 2.5) | python-elementtree,
                      python-cheetah
-Standards-Version: 3.9.1
+Standards-Version: 3.9.3
 Vcs-Git: git://git.debian.org/git/pkg-telepathy/telepathy-spec.git
 Vcs-Browser: http://git.debian.org/?p=pkg-telepathy/telepathy-spec.git
 Homepage: http://telepathy.freedesktop.org/wiki/

## telepathy-spec 0.27.1

=== Makefile ===
all:

GIT = git
GZIP = gzip
TAR = tar
PYTHON = python

DOC_RSYNC_FLAGS=-rvzPp --chmod=Dg+s,ug+rwX,o=rX --delete

XMLS = $(wildcard spec/*.xml)
TEMPLATES = $(wildcard doc/templates/*)

VERSION := $(shell sed -ne s'!<tp:version>\(.*\)</tp:version>!\1!p' spec/all.xml)
DISTNAME := telepathy-spec-$(VERSION)

GENERATED_FILES = \
	doc/spec/index.html \
	FIXME.out \
	$(NULL)

doc/spec/index.html: $(XMLS) tools/doc-generator.py tools/specparser.py $(TEMPLATES)
	rm -rf doc/spec
	install -d doc/spec
	$(PYTHON) tools/doc-generator.py spec/all.xml doc/spec/ telepathy-spec \
		org.freedesktop.Telepathy

all: $(GENERATED_FILES)
	@echo "Your spec HTML starts at:"
	@echo
	@echo file://$(CURDIR)/doc/spec/index.html
	@echo

CHECK_FOR_UNRELEASED = NEWS $(filter-out spec/template.xml,$(XMLS))

check: all FIXME.out
	$(PYTHON) test/test-specparser.py
	@case "$(VERSION)" in \
		*.*.*.*) ;; \
		*) \
			echo "Grepping spec for UNRELEASED..."; \
			if grep -r UNRELEASED $(CHECK_FOR_UNRELEASED); \
			then \
				echo "^^^ This is meant to be a release, but some files say UNRELEASED" >&2; \
				exit 2; \
			fi \
			;; \
	esac

FIXME.out: $(XMLS)
	@echo '  GEN   ' $@
	@egrep -A 5 '[F]IXME|[T]ODO|[X]XX' $(XMLS) \
		> FIXME.out || true

clean:
	rm -f $(GENERATED_FILES)
	rm -rf test/output
	rm -rf tmp
	rm -rf doc/spec

maintainer-upload-snapshot: doc/spec/index.html
	@install -d tmp
	rsync $(DOC_RSYNC_FLAGS) doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/
	@echo The snapshot lives at:
	@echo '  ' http://telepathy.freedesktop.org/spec-snapshot/

maintainer-upload-release: doc/spec/index.html check
	@install -d tmp
	@if ! echo $(VERSION) | egrep '[0-9]+\.[0-9]+\.[0-9]+'; then \
		echo $(VERSION) 'does not look like a spec release'; \
		exit 1; \
	fi
	test -f telepathy-spec-$(VERSION).tar.gz
	test -f telepathy-spec-$(VERSION).tar.gz.asc
	gpg --verify telepathy-spec-$(VERSION).tar.gz.asc
	rsync -vzP telepathy-spec-$(VERSION).tar.gz telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/
	rsync -vzP telepathy-spec-$(VERSION).tar.gz.asc telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/releases/telepathy-spec/
	rsync $(DOC_RSYNC_FLAGS) doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec/
	rsync $(DOC_RSYNC_FLAGS) doc/spec/ telepathy.freedesktop.org:/srv/telepathy.freedesktop.org/www/spec-snapshot/

dist: check
	@install -d tmp
	rm -f tmp/ChangeLog "$(DISTNAME)".tar "$(DISTNAME)".tar.gz
	$(GIT) archive --format=tar --prefix="$(DISTNAME)"/ "HEAD^{tree}" \
		> "$(DISTNAME)".tar
	rm -rf tmp/"$(DISTNAME)"
	mkdir tmp/"$(DISTNAME)"
	$(GIT) log telepathy-spec-0.16.0.. > tmp/"$(DISTNAME)"/ChangeLog
	$(TAR) -rf "$(DISTNAME)".tar -C tmp --owner 0 --group 0 --mode 0664 \
		"$(DISTNAME)"/ChangeLog
	$(GZIP) -9 "$(DISTNAME)".tar
	rm -rf tmp/"$(DISTNAME)"

BRANCH = $(shell sh tools/git-which-branch.sh misc | tr -d '\n' | tr -C "[:alnum:]" _)
UPLOAD_BRANCH_HOST = people.freedesktop.org
UPLOAD_BRANCH_TO = $(UPLOAD_BRANCH_HOST):public_html/telepathy-spec

# Usage: make upload-branch BRANCH=discussion
upload-branch: all
	rsync -rzvP --delete doc/spec \
		$(UPLOAD_BRANCH_TO)-$(BRANCH)/
	@echo Your spec branch might be at:
	@echo '  ' http://$(UPLOAD_BRANCH_HOST)/~$$USER/telepathy-spec-$(BRANCH)/spec/

# automake requires these rules for anything that's in DIST_SUBDIRS
distclean: clean
maintainer-clean: clean
distdir:
	@echo distdir not implemented yet; exit 1

.PHONY: \
    all \
    check \
    clean \
    dist \
    distclean \
    distdir \
    maintainer-clean \
    maintainer-upload-release \
    maintainer-upload-snapshot \
    upload-branch \
    $(NULL)

=== debian/changelog ===
telepathy-spec (0.27.1-1) unstable; urgency=low

  * New upstream release
  * Canonicalize Vcs-*
  * Standards-Version: 3.9.4, no changes needed

 -- Simon McVittie <smcv@debian.org>  Mon, 16 Sep 2013 16:39:42 +0100

=== debian/control ===
--- 
+++ 
@@ -11,9 +11,9 @@
 Build-Depends-Indep: xsltproc,
                      python (>= 2.5) | python-elementtree,
                      python-cheetah
-Standards-Version: 3.9.3
-Vcs-Git: git://git.debian.org/git/pkg-telepathy/telepathy-spec.git
-Vcs-Browser: http://git.debian.org/?p=pkg-telepathy/telepathy-spec.git
+Standards-Version: 3.9.4
+Vcs-Git: git://anonscm.debian.org/pkg-telepathy/telepathy-spec.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-telepathy/telepathy-spec.git
 Homepage: http://telepathy.freedesktop.org/wiki/
 
 Package: telepathy-specification

## telepathy-spec 0.27.3

=== debian/changelog ===
telepathy-spec (0.27.3-1) unstable; urgency=medium

  * debian/watch: don't watch for versions 0.99.x, which are snapshots of
    telepathy-spec 1.0 and should be packaged separately
  * New upstream release
  * Standards-Version: 3.9.5, no changes needed

 -- Simon McVittie <smcv@debian.org>  Tue, 16 Sep 2014 14:55:01 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Build-Depends-Indep: xsltproc,
                      python (>= 2.5) | python-elementtree,
                      python-cheetah
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Git: git://anonscm.debian.org/pkg-telepathy/telepathy-spec.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-telepathy/telepathy-spec.git
 Homepage: http://telepathy.freedesktop.org/wiki/

=== debian/watch ===
version=3
http://telepathy.freedesktop.org/releases/telepathy-spec/telepathy-spec-(0\.[0-8].*).tar.gz

## telepathy-spec 0.27.4

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 GIT = git
 GZIP = gzip
 TAR = tar
-PYTHON = python
+PYTHON = python3
 
 DOC_RSYNC_FLAGS=-rvzPp --chmod=Dg+s,ug+rwX,o=rX --delete

=== debian/changelog ===
telepathy-spec (0.27.4-1) unstable; urgency=medium

  [ Simon McVittie ]
  * Remove myself from Uploaders

  [ Jonny Lamb ]
  * Remove myself from Uploaders.

  [ Laurent Bigonville ]
  * New upstream release
    - Switch build-dependencies to python3, also switch from cheetah to jinja2
      (Closes: #939482)
  * Bump debhelper compatibility to 12
  * debian/control: Bump Standards-Version to 4.4.1 (no further changes)
  * debian/control, debian/watch: Use https://
  * debian/control: Update the Vcs-* fields, git repository has moved to salsa
    (Closes: #907462)
  * debian/telepathy-specification.links: Fix broken symlink (Closes: #924222)
  * debian/doc-base: Fix the paths to please lintian
  * Add gpg verification of the upstream tarball

 -- Laurent Bigonville <bigon@debian.org>  Mon, 30 Dec 2019 12:48:21 +0100

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,16 @@
 Priority: optional
 Maintainer: Debian Telepathy maintainers <pkg-telepathy-maintainers@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>,
-           Simon McVittie <smcv@debian.org>,
            Sjoerd Simons <sjoerd@debian.org>,
-           Jonny Lamb <jonny@debian.org>,
            Emilio Pozuelo Monfort <pochu@debian.org>
-Build-Depends: debhelper (>= 7.0.50)
+Build-Depends: debhelper (>= 12)
 Build-Depends-Indep: xsltproc,
-                     python (>= 2.5) | python-elementtree,
-                     python-cheetah
-Standards-Version: 3.9.5
-Vcs-Git: git://anonscm.debian.org/pkg-telepathy/telepathy-spec.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-telepathy/telepathy-spec.git
-Homepage: http://telepathy.freedesktop.org/wiki/
+                     python3,
+                     python3-jinja2
+Standards-Version: 4.4.1
+Vcs-Git: https://salsa.debian.org/telepathy-team/telepathy-spec.git
+Vcs-Browser: https://salsa.debian.org/telepathy-team/telepathy-spec/
+Homepage: https://telepathy.freedesktop.org/wiki/
 
 Package: telepathy-specification
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_test:
	# skip "make check", it's not actually very useful in this package

override_dh_compress:
	dh_compress -X.xml

spec=debian/telepathy-specification/usr/share/gtk-doc/html/telepathy-spec

override_dh_link:
	rm $(spec)/jquery.min.js
	dh_link

=== debian/watch ===
version=4
opts=pgpmode=auto \
https://telepathy.freedesktop.org/releases/telepathy-spec/telepathy-spec-(0\.[0-8].*).tar.gz
